Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 8865)
@@ -1,3 +1,6 @@
 MODULE dynspg_ts
+
+   !! Includes ROMS wd scheme with diagnostic outputs ; un and ua updates are commented out ! 
+
    !!======================================================================
    !!                   ***  MODULE  dynspg_ts  ***
@@ -150,4 +153,8 @@
       REAL(wp) ::   zhura, zhvra         	!   -      -
       REAL(wp) ::   za0, za1, za2, za3		!   -      -
+      REAL(wp) ::   zwdramp                     ! local scalar - only used if ln_rwd = .True. 
+
+      INTEGER  :: iwdg, jwdg, kwdg   ! short-hand values for the indices of the output point
+
       !
       REAL(wp), POINTER, DIMENSION(:,:) :: zsshp2_e
@@ -158,4 +165,6 @@
       REAL(wp), POINTER, DIMENSION(:,:) :: zhf
       REAL(wp), POINTER, DIMENSION(:,:) :: zcpx, zcpy                 ! Wetting/Dying gravity filter coef.
+      REAL(wp), POINTER, DIMENSION(:,:) :: ztwdmask, zuwdmask, zvwdmask ! ROMS wetting and drying masks at t,u,v points
+      REAL(wp), POINTER, DIMENSION(:,:) :: zuwdav2, zvwdav2    ! averages over the sub-steps of zuwdmask and zvwdmask
       !!----------------------------------------------------------------------
       !
@@ -170,4 +179,11 @@
       CALL wrk_alloc( jpi,jpj,   zhf )
       IF( ln_wd ) CALL wrk_alloc( jpi, jpj, zcpx, zcpy )
+      IF( ln_rwd ) CALL wrk_alloc( jpi, jpj, ztwdmask, zuwdmask, zvwdmask, zuwdav2, zvwdav2)
+
+      IF ( ln_wd_diag ) THEN 
+         iwdg = jn_wd_i ; jwdg = jn_wd_j ; kwdg = jn_wd_k
+         WRITE(numout,*) 'kt, iwdg, jwdg, kwdg = ', kt, iwdg, jwdg, kwdg 
+      END IF 
+
       !
       zmdi=1.e+20                               !  missing data indicator for masking
@@ -178,4 +194,6 @@
       z1_2  = 0.5_wp     
       zraur = 1._wp / rau0
+      zwdramp = 1._wp / rn_wdmin1                 ! simplest ramp 
+!     zwdramp = 1._wp / (rn_wdmin2 - rn_wdmin1)   ! more general ramp
       !  	                                       ! reciprocal of baroclinic time step 
       IF( kt == nit000 .AND. neuler == 0 ) THEN   ;   z2dt_bf =          rdt
@@ -403,10 +421,10 @@
               DO ji = 2, jpim1 
                 ll_tmp1 = MIN(   sshn(ji,jj)               ,   sshn(ji+1,jj) ) >                &
-                     &    MAX( -ht_wd(ji,jj)               , -ht_wd(ji+1,jj) ) .AND.            &
-                     &    MAX(   sshn(ji,jj) + ht_wd(ji,jj),   sshn(ji+1,jj) + ht_wd(ji+1,jj) ) &
+                     &    MAX( -ht_0(ji,jj)               , -ht_0(ji+1,jj) ) .AND.            &
+                     &    MAX(   sshn(ji,jj) + ht_0(ji,jj),   sshn(ji+1,jj) + ht_0(ji+1,jj) ) &
                      &                                                         > rn_wdmin1 + rn_wdmin2
                 ll_tmp2 = ( ABS( sshn(ji+1,jj)             -   sshn(ji  ,jj))  > 1.E-12 ).AND.( &
                      &    MAX(   sshn(ji,jj)               ,   sshn(ji+1,jj) ) >                &
-                     &    MAX( -ht_wd(ji,jj)               , -ht_wd(ji+1,jj) ) + rn_wdmin1 + rn_wdmin2 )
+                     &    MAX( -ht_0(ji,jj)               , -ht_0(ji+1,jj) ) + rn_wdmin1 + rn_wdmin2 )
    
                 IF(ll_tmp1) THEN
@@ -414,6 +432,8 @@
                 ELSE IF(ll_tmp2) THEN
                   ! no worries about  sshn(ji+1,jj) -  sshn(ji  ,jj) = 0, it won't happen ! here
-                  zcpx(ji,jj) = ABS( (sshn(ji+1,jj) + ht_wd(ji+1,jj) - sshn(ji,jj) - ht_wd(ji,jj)) &
+                  zcpx(ji,jj) = ABS( (sshn(ji+1,jj) + ht_0(ji+1,jj) - sshn(ji,jj) - ht_0(ji,jj)) &
                               &    / (sshn(ji+1,jj) -  sshn(ji  ,jj)) )
+                  zcpx(ji,jj) = max(min( zcpx(ji,jj) , 1.0_wp),0.0_wp)
+
                 ELSE
                   zcpx(ji,jj) = 0._wp
@@ -421,10 +441,10 @@
          
                 ll_tmp1 = MIN(   sshn(ji,jj)               ,   sshn(ji,jj+1) ) >                &
-                     &    MAX( -ht_wd(ji,jj)               , -ht_wd(ji,jj+1) ) .AND.            &
-                     &    MAX(   sshn(ji,jj) + ht_wd(ji,jj),   sshn(ji,jj+1) + ht_wd(ji,jj+1) ) &
+                     &    MAX( -ht_0(ji,jj)               , -ht_0(ji,jj+1) ) .AND.            &
+                     &    MAX(   sshn(ji,jj) + ht_0(ji,jj),   sshn(ji,jj+1) + ht_0(ji,jj+1) ) &
                      &                                                         > rn_wdmin1 + rn_wdmin2
                 ll_tmp2 = ( ABS( sshn(ji,jj)               -   sshn(ji,jj+1))  > 1.E-12 ).AND.( &
                      &    MAX(   sshn(ji,jj)               ,   sshn(ji,jj+1) ) >                &
-                     &    MAX( -ht_wd(ji,jj)               , -ht_wd(ji,jj+1) ) + rn_wdmin1 + rn_wdmin2 )
+                     &    MAX( -ht_0(ji,jj)               , -ht_0(ji,jj+1) ) + rn_wdmin1 + rn_wdmin2 )
    
                 IF(ll_tmp1) THEN
@@ -432,6 +452,8 @@
                 ELSE IF(ll_tmp2) THEN
                   ! no worries about  sshn(ji,jj+1) -  sshn(ji,jj  ) = 0, it won't happen ! here
-                  zcpy(ji,jj) = ABS( (sshn(ji,jj+1) + ht_wd(ji,jj+1) - sshn(ji,jj) - ht_wd(ji,jj)) &
+                  zcpy(ji,jj) = ABS( (sshn(ji,jj+1) + ht_0(ji,jj+1) - sshn(ji,jj) - ht_0(ji,jj)) &
                               &    / (sshn(ji,jj+1) -  sshn(ji,jj  )) )
+                  zcpy(ji,jj) = max(min( zcpy(ji,jj) , 1.0_wp),0.0_wp)
+
                 ELSE
                   zcpy(ji,jj) = 0._wp
@@ -443,7 +465,8 @@
               DO ji = 2, jpim1
                  zu_trd(ji,jj) = zu_trd(ji,jj) - grav * ( sshn(ji+1,jj  ) - sshn(ji  ,jj ) )   &
-                        &                        * r1_e1u(ji,jj) * zcpx(ji,jj)
+                        &                        * r1_e1u(ji,jj) * zcpx(ji,jj)  * wdrampu(ji,jj)  !jth
                  zv_trd(ji,jj) = zv_trd(ji,jj) - grav * ( sshn(ji  ,jj+1) - sshn(ji  ,jj ) )   &
-                        &                        * r1_e2v(ji,jj) * zcpy(ji,jj)
+                        &                        * r1_e2v(ji,jj) * zcpy(ji,jj)  * wdrampv(ji,jj)  !jth
+
               END DO
            END DO
@@ -491,6 +514,6 @@
       ! Note that the "unclipped" bottom friction parameter is used even with explicit drag
       IF( ln_wd ) THEN
-        zu_frc(:,:) = zu_frc(:,:) + MAX(r1_hu_n(:,:) * bfrua(:,:),-1._wp / rdtbt) * zwx(:,:)
-        zv_frc(:,:) = zv_frc(:,:) + MAX(r1_hv_n(:,:) * bfrva(:,:),-1._wp / rdtbt) * zwy(:,:)
+        zu_frc(:,:) = zu_frc(:,:) + MAX(r1_hu_n(:,:) * bfrua(:,:),-1._wp / rdtbt) * zwx(:,:) *  wdrampu(ji,jj)
+        zv_frc(:,:) = zv_frc(:,:) + MAX(r1_hv_n(:,:) * bfrva(:,:),-1._wp / rdtbt) * zwy(:,:) *  wdrampv(ji,jj)
       ELSE
         zu_frc(:,:) = zu_frc(:,:) + r1_hu_n(:,:) * bfrua(:,:) * zwx(:,:)
@@ -627,4 +650,13 @@
       vn_adv(:,:) = 0._wp
       !                                             ! ==================== !
+
+      IF (ln_rwd) THEN
+         zuwdmask(:,:) = 0._wp  ! set to zero for definiteness (not sure this is necessary) 
+         zvwdmask(:,:) = 0._wp  ! 
+         zuwdav2(:,:) =  0._wp 
+         zvwdav2(:,:) =  0._wp   
+      END IF 
+
+
       DO jn = 1, icycle                             !  sub-time-step loop  !
          !                                          ! ==================== !
@@ -654,5 +686,40 @@
             ! Extrapolate Sea Level at step jit+0.5:
             zsshp2_e(:,:) = za1 * sshn_e(:,:)  + za2 * sshb_e(:,:) + za3 * sshbb_e(:,:)
-            !
+            
+            ! set wetting & drying mask at tracer points for this barotropic sub-step 
+            IF ( ln_rwd ) THEN 
+
+               IF ( ln_rwd_rmp ) THEN 
+                  DO jj = 1, jpj                                 
+                     DO ji = 1, jpi   ! vector opt.  
+                        IF ( zsshp2_e(ji,jj) + ht_0(ji,jj) >  2._wp * rn_wdmin1 ) THEN 
+!                        IF ( zsshp2_e(ji,jj) + ht_0(ji,jj) >  rn_wdmin2 ) THEN 
+                           ztwdmask(ji,jj) = 1._wp
+                        ELSE IF ( zsshp2_e(ji,jj) + ht_0(ji,jj) >  rn_wdmin1 ) THEN
+                           ztwdmask(ji,jj) = (tanh(50._wp*( ( zsshp2_e(ji,jj) + ht_0(ji,jj) -  rn_wdmin1 )/rn_wdmin1)) ) 
+                        ELSE 
+                           ztwdmask(ji,jj) = 0._wp
+                        END IF
+                     END DO
+                  END DO
+               ELSE
+                  DO jj = 1, jpj                                 
+                     DO ji = 1, jpi   ! vector opt.  
+                        IF ( zsshp2_e(ji,jj) + ht_0(ji,jj) >  rn_wdmin1 ) THEN 
+                           ztwdmask(ji,jj) = 1._wp
+                        ELSE 
+                           ztwdmask(ji,jj) = 0._wp
+                        END IF
+                     END DO
+                  END DO
+               END IF 
+
+               IF ( ln_wd_diag ) WRITE(numout,*) 'kt, jn = ', kt, jn 
+               IF ( ln_wd_diag ) WRITE(numout, *) 'zsshp2_e: (i,j), (i+1,j), (i,j+1) = ', zsshp2_e(iwdg,jwdg), zsshp2_e(iwdg+1,jwdg), zsshp2_e(iwdg,jwdg+1)
+               IF ( ln_wd_diag ) WRITE(numout, *) 'ht_0:     (i,j), (i+1,j), (i,j+1) = ', ht_0(iwdg,jwdg), ht_0(iwdg+1,jwdg), (iwdg,jwdg+1)
+               IF ( ln_wd_diag ) WRITE(numout, *) 'ztwdmask: (i,j), (i+1,j), (i,j+1) = ', ztwdmask(iwdg,jwdg), ztwdmask(iwdg+1,jwdg), ztwdmask(iwdg,jwdg+1) 
+            END IF 
+           
+
             DO jj = 2, jpjm1                                    ! Sea Surface Height at u- & v-points
                DO ji = 2, fs_jpim1   ! Vector opt.
@@ -707,10 +774,66 @@
 #endif
          IF( ln_wd ) CALL wad_lmt_bt(zwx, zwy, sshn_e, zssh_frc, rdtbt)
-         !
+
+         IF ( ln_rwd ) THEN 
+
+            IF ( ln_wd_diag ) THEN 
+               WRITE(numout, *) 'zwx: (i,j), (i+1,j) = ', zwx(iwdg,jwdg), zwx(iwdg+1,jwdg)
+               WRITE(numout, *) 'zwy: (i,j), (i,j+1) = ', zwy(iwdg,jwdg), zwx(iwdg,jwdg+1)
+            END IF 
+
+! un_e and vn_e are set to zero at faces where the direction of the flow is from dry cells 
+
+            DO jj = 1, jpjm1                                 
+               DO ji = 1, jpim1   
+                  IF ( zwx(ji,jj) > 0.0 ) THEN 
+                     zuwdmask(ji, jj) = ztwdmask(ji  ,jj) 
+                  ELSE 
+                     zuwdmask(ji, jj) = ztwdmask(ji+1,jj)  
+                  END IF 
+                  zwx(ji, jj) = zuwdmask(ji,jj)*zwx(ji, jj)
+                  un_e(ji,jj) = zuwdmask(ji,jj)*un_e(ji,jj)
+
+                  IF ( zwy(ji,jj) > 0.0 ) THEN
+                     zvwdmask(ji, jj) = ztwdmask(ji, jj  )
+                  ELSE 
+                     zvwdmask(ji, jj) = ztwdmask(ji, jj+1)  
+                  END IF 
+                  zwy(ji, jj) = zvwdmask(ji,jj)*zwy(ji,jj) 
+                  vn_e(ji,jj) = zvwdmask(ji,jj)*vn_e(ji,jj)
+               END DO
+            END DO
+
+            IF ( ln_wd_diag ) THEN 
+               WRITE(numout, *) 'zuwdmask: (i,j)     = ', zuwdmask(iwdg,jwdg)
+               WRITE(numout, *) 'zwx: (i,j)          = ', zwx(iwdg,jwdg)
+               WRITE(numout, *) 'e2u: (i,j)          = ', e2u(iwdg,jwdg)
+               WRITE(numout, *) 'ua_e: (i,j)         = ', ua_e(iwdg,jwdg)
+               WRITE(numout, *) 'un_e: (i,j)         = ', un_e(iwdg,jwdg)
+               WRITE(numout, *) 'zhup2_e: (i,j)      = ', zhup2_e(iwdg,jwdg)
+               WRITE(numout, *) 'zvwdmask: (i,j)     = ', zvwdmask(iwdg,jwdg)
+               WRITE(numout, *) 'zwy: (i,j)          = ', zwy(iwdg,jwdg) 
+            END IF 
+
+         END IF    
+         
          ! Sum over sub-time-steps to compute advective velocities
          za2 = wgtbtp2(jn)
          un_adv(:,:) = un_adv(:,:) + za2 * zwx(:,:) * r1_e2u(:,:)
          vn_adv(:,:) = vn_adv(:,:) + za2 * zwy(:,:) * r1_e1v(:,:)
-         !
+         
+         ! sum over sub-time-steps to decide which baroclinic velocities to set to zero (zuwdav2 is only used when ln_rwd_bc = True) 
+         IF ( ln_rwd_bc ) THEN
+            zuwdav2(:,:) = zuwdav2(:,:) + za2 * zuwdmask(:,:)
+            zvwdav2(:,:) = zvwdav2(:,:) + za2 * zvwdmask(:,:)
+
+            IF ( ln_wd_diag ) THEN 
+               WRITE(numout, *) 'za2, r1_e2u(i,j)     = ', za2, r1_e2u(iwdg,jwdg) 
+               WRITE(numout, *) 'un_adv: (i,j)        = ', un_adv(iwdg,jwdg)
+               WRITE(numout, *) 'zuwdav2: (i,j)       = ', zuwdav2(iwdg,jwdg)
+               WRITE(numout, *) 'zvwdav2: (i,j)       = ', zvwdav2(iwdg,jwdg)
+            END IF 
+
+         END IF 
+
          ! Set next sea level:
          DO jj = 2, jpjm1                                 
@@ -770,10 +893,10 @@
               DO ji = 2, jpim1 
                 ll_tmp1 = MIN( zsshp2_e(ji,jj)               , zsshp2_e(ji+1,jj) ) >                &
-                     &    MAX(   -ht_wd(ji,jj)               ,   -ht_wd(ji+1,jj) ) .AND.            &
-                     &    MAX( zsshp2_e(ji,jj) + ht_wd(ji,jj), zsshp2_e(ji+1,jj) + ht_wd(ji+1,jj) ) &
+                     &    MAX(   -ht_0(ji,jj)               ,   -ht_0(ji+1,jj) ) .AND.            &
+                     &    MAX( zsshp2_e(ji,jj) + ht_0(ji,jj), zsshp2_e(ji+1,jj) + ht_0(ji+1,jj) ) &
                      &                                                             > rn_wdmin1 + rn_wdmin2
                 ll_tmp2 = (ABS(zsshp2_e(ji,jj)               - zsshp2_e(ji+1,jj))  > 1.E-12 ).AND.( &
                      &    MAX( zsshp2_e(ji,jj)               , zsshp2_e(ji+1,jj) ) >                &
-                     &    MAX(   -ht_wd(ji,jj)               ,   -ht_wd(ji+1,jj) ) + rn_wdmin1 + rn_wdmin2 )
+                     &    MAX(   -ht_0(ji,jj)               ,   -ht_0(ji+1,jj) ) + rn_wdmin1 + rn_wdmin2 )
    
                 IF(ll_tmp1) THEN
@@ -781,5 +904,5 @@
                 ELSE IF(ll_tmp2) THEN
                   ! no worries about  zsshp2_e(ji+1,jj) - zsshp2_e(ji  ,jj) = 0, it won't happen ! here
-                  zcpx(ji,jj) = ABS( (zsshp2_e(ji+1,jj) +    ht_wd(ji+1,jj) - zsshp2_e(ji,jj) - ht_wd(ji,jj)) &
+                  zcpx(ji,jj) = ABS( (zsshp2_e(ji+1,jj) +    ht_0(ji+1,jj) - zsshp2_e(ji,jj) - ht_0(ji,jj)) &
                               &    / (zsshp2_e(ji+1,jj) - zsshp2_e(ji  ,jj)) )
                 ELSE
@@ -788,10 +911,10 @@
          
                 ll_tmp1 = MIN( zsshp2_e(ji,jj)               , zsshp2_e(ji,jj+1) ) >                &
-                     &    MAX(   -ht_wd(ji,jj)               ,   -ht_wd(ji,jj+1) ) .AND.            &
-                     &    MAX( zsshp2_e(ji,jj) + ht_wd(ji,jj), zsshp2_e(ji,jj+1) + ht_wd(ji,jj+1) ) &
+                     &    MAX(   -ht_0(ji,jj)               ,   -ht_0(ji,jj+1) ) .AND.            &
+                     &    MAX( zsshp2_e(ji,jj) + ht_0(ji,jj), zsshp2_e(ji,jj+1) + ht_0(ji,jj+1) ) &
                      &                                                             > rn_wdmin1 + rn_wdmin2
                 ll_tmp2 = (ABS(zsshp2_e(ji,jj)               - zsshp2_e(ji,jj+1))  > 1.E-12 ).AND.( &
                      &    MAX( zsshp2_e(ji,jj)               , zsshp2_e(ji,jj+1) ) >                &
-                     &    MAX(   -ht_wd(ji,jj)               ,   -ht_wd(ji,jj+1) ) + rn_wdmin1 + rn_wdmin2 )
+                     &    MAX(   -ht_0(ji,jj)               ,   -ht_0(ji,jj+1) ) + rn_wdmin1 + rn_wdmin2 )
    
                 IF(ll_tmp1) THEN
@@ -799,5 +922,5 @@
                 ELSE IF(ll_tmp2) THEN
                   ! no worries about  zsshp2_e(ji,jj+1) - zsshp2_e(ji,jj  ) = 0, it won't happen ! here
-                  zcpy(ji,jj) = ABS( (zsshp2_e(ji,jj+1) +    ht_wd(ji,jj+1) - zsshp2_e(ji,jj) - ht_wd(ji,jj)) &
+                  zcpy(ji,jj) = ABS( (zsshp2_e(ji,jj+1) +    ht_0(ji,jj+1) - zsshp2_e(ji,jj) - ht_0(ji,jj)) &
                               &    / (zsshp2_e(ji,jj+1) - zsshp2_e(ji,jj  )) )
                 ELSE
@@ -886,6 +1009,7 @@
          !
          ! Add bottom stresses:
-         zu_trd(:,:) = zu_trd(:,:) + bfrua(:,:) * un_e(:,:) * hur_e(:,:)
-         zv_trd(:,:) = zv_trd(:,:) + bfrva(:,:) * vn_e(:,:) * hvr_e(:,:)
+!jth do implicitly instead
+!         zu_trd(:,:) = zu_trd(:,:) + bfrua(:,:) * un_e(:,:) * hur_e(:,:)
+!         zv_trd(:,:) = zv_trd(:,:) + bfrva(:,:) * vn_e(:,:) * hvr_e(:,:)
          !
          ! Add top stresses:
@@ -933,4 +1057,9 @@
                             &                                 + zv_frc(ji,jj) ) &
                             &   ) * ssvmask(ji,jj)
+ 
+!jth implicit bottom friction:
+               ua_e(ji,jj) =  ua_e(ji,jj) /(1.0 -   rdtbt * bfrua(ji,jj) * hur_e(ji,jj))
+               va_e(ji,jj) =  va_e(ji,jj) /(1.0 -   rdtbt * bfrva(ji,jj) * hvr_e(ji,jj))
+
                END DO
             END DO
@@ -941,6 +1070,6 @@
 
                   IF( ln_wd ) THEN
-                    zhura = MAX(hu_0(ji,jj) + zsshu_a(ji,jj), rn_wdmin1)
-                    zhvra = MAX(hv_0(ji,jj) + zsshv_a(ji,jj), rn_wdmin1)
+                    zhura = hu_0(ji,jj) + zsshu_a(ji,jj)
+                    zhvra = hv_0(ji,jj) + zsshv_a(ji,jj)
                   ELSE
                     zhura = hu_0(ji,jj) + zsshu_a(ji,jj)
@@ -964,9 +1093,25 @@
             END DO
          ENDIF
-         !
+
+! if ln_rwd: ua_e and va_e should not be masked ; they are used to determine the direction of flow into all cells
+
+!         IF ( ln_rwd) THEN 
+!            IF ( ln_wd_diag ) THEN 
+!               WRITE(numout, *) 'ua_e: (i,j)         = ', ua_e(iwdg,jwdg)
+!               WRITE(numout, *) 'va_e: (i,j)         = ', va_e(iwdg,jwdg)
+!            END IF 
+!            ua_e(:,:) = ua_e(:,:) * zuwdmask(:,:) 
+!            va_e(:,:) = va_e(:,:) * zvwdmask(:,:) 
+!            IF ( ln_wd_diag ) THEN 
+!               WRITE(numout, *) 'ua_e: (i,j)         = ', ua_e(iwdg,jwdg)
+!               WRITE(numout, *) 'va_e: (i,j)         = ', va_e(iwdg,jwdg)
+!            END IF 
+!         END IF 
+
+         
          IF( .NOT.ln_linssh ) THEN                     !* Update ocean depth (variable volume case only)
             IF( ln_wd ) THEN
-              hu_e (:,:) = MAX(hu_0(:,:) + zsshu_a(:,:), rn_wdmin1)
-              hv_e (:,:) = MAX(hv_0(:,:) + zsshv_a(:,:), rn_wdmin1)
+              hu_e (:,:) = hu_0(:,:) + zsshu_a(:,:)
+              hv_e (:,:) = hv_0(:,:) + zsshv_a(:,:)
             ELSE
               hu_e (:,:) = hu_0(:,:) + zsshu_a(:,:)
@@ -1006,9 +1151,15 @@
             va_b  (:,:) = va_b  (:,:) + za1 * va_e  (:,:) 
          ELSE                                              ! Sum transports
-            ua_b  (:,:) = ua_b  (:,:) + za1 * ua_e  (:,:) * hu_e (:,:)
-            va_b  (:,:) = va_b  (:,:) + za1 * va_e  (:,:) * hv_e (:,:)
+            IF (.NOT.ln_rwd) THEN  
+               ua_b  (:,:) = ua_b  (:,:) + za1 * ua_e  (:,:) * hu_e (:,:)
+               va_b  (:,:) = va_b  (:,:) + za1 * va_e  (:,:) * hv_e (:,:)
+            ELSE 
+               ua_b  (:,:) = ua_b  (:,:) + za1 * ua_e  (:,:) * hu_e (:,:) * zuwdmask(:,:)
+               va_b  (:,:) = va_b  (:,:) + za1 * va_e  (:,:) * hv_e (:,:) * zvwdmask(:,:)
+            END IF 
          ENDIF
          !                       			   ! Sum sea level
          ssha(:,:) = ssha(:,:) + za1 * ssha_e(:,:)
+
          !                                                 ! ==================== !
       END DO                                               !        end loop      !
@@ -1033,4 +1184,12 @@
          vb2_b(:,:) = zwy(:,:)
       ENDIF
+
+      IF ( ln_wd_diag ) THEN 
+         WRITE(numout, *) 'ub2_b: (i,j)        = ', ub2_b(iwdg,jwdg)
+         WRITE(numout, *) 'r1_hu_n: (i,j)      = ', r1_hu_n(iwdg,jwdg)
+         WRITE(numout, *) 'zwx: (i,j)          = ', zwx(iwdg,jwdg)
+         WRITE(numout, *) 'un_adv: (i,j)        = ', un_adv(iwdg,jwdg)
+      END IF 
+
       !
       ! Update barotropic trend:
@@ -1062,12 +1221,46 @@
          va_b(:,:) =  va_b(:,:) / ( hv_0(:,:) + zsshv_a(:,:) + 1._wp - ssvmask(:,:) )
       ENDIF
-      !
+
+      IF ( ln_wd_diag ) THEN 
+         WRITE(numout, *) 'ua_b: (i,j) A        = ', ua_b(iwdg,jwdg)
+         WRITE(numout, *) 'va_b: (i,j) B        = ', va_b(iwdg,jwdg)
+      END IF 
+
+! temporary debugging code 
+      IF ( ln_wd_diag ) THEN 
+         WRITE(numout, *) 'ua: (i,j,k)  B       = ', ua(iwdg,jwdg,kwdg)
+         WRITE(numout, *) 'ua_b: (i,j)  B       = ', ua_b(iwdg,jwdg)
+         WRITE(numout, *) 'un: (i,j,k)          = ', un(iwdg,jwdg,kwdg)
+         WRITE(numout, *) 'un_b: (i,j)          = ', un_b(iwdg,jwdg)
+         WRITE(numout, *) 'un_adv: (i,j)        = ', un_adv(iwdg,jwdg)
+         WRITE(numout, *) 'va: (i,j,k)          = ', va(iwdg,jwdg,kwdg)
+         WRITE(numout, *) 'va_b: (i,j,k)        = ', va_b(iwdg,jwdg)
+         WRITE(numout, *) 'vn: (i,j,k)          = ', vn(iwdg,jwdg,kwdg)
+         WRITE(numout, *) 'vn_b: (i,j)          = ', vn_b(iwdg,jwdg)
+         WRITE(numout, *) 'vn_adv: (i,j)        = ', vn_adv(iwdg,jwdg)
+      END IF 
+
+      ! Correct velocities so that the barotropic velocity equals (un_adv, vn_adv) (in all cases)  
       DO jk = 1, jpkm1
-         ! Correct velocities:
          un(:,:,jk) = ( un(:,:,jk) + un_adv(:,:) - un_b(:,:) ) * umask(:,:,jk)
          vn(:,:,jk) = ( vn(:,:,jk) + vn_adv(:,:) - vn_b(:,:) ) * vmask(:,:,jk)
-         !
       END DO
-      !
+
+      IF ( ln_rwd .and. ln_rwd_bc) THEN 
+         DO jk = 1, jpkm1
+            un(:,:,jk) = ( un_adv(:,:) + zuwdav2(:,:)*(un(:,:,jk) - un_adv(:,:)) ) * umask(:,:,jk) 
+            vn(:,:,jk) = ( vn_adv(:,:) + zvwdav2(:,:)*(vn(:,:,jk) - vn_adv(:,:)) ) * vmask(:,:,jk)  
+         END DO
+      END IF 
+
+      IF ( ln_wd_diag ) THEN 
+         WRITE(numout, *) 'ua: (i,j,k)          = ', ua(iwdg,jwdg,kwdg)
+         WRITE(numout, *) 'ua_b: (i,j,k)        = ', ua_b(iwdg,jwdg)
+         WRITE(numout, *) 'un: (i,j,k)          = ', un(iwdg,jwdg,kwdg)
+         WRITE(numout, *) 'va: (i,j,k)          = ', va(iwdg,jwdg,kwdg)
+         WRITE(numout, *) 'va_b: (i,j,k)        = ', va_b(iwdg,jwdg)
+         WRITE(numout, *) 'vn: (i,j,k)          = ', vn(iwdg,jwdg,kwdg)
+      END IF 
+      
       CALL iom_put(  "ubar", un_adv(:,:)      )    ! barotropic i-current
       CALL iom_put(  "vbar", vn_adv(:,:)      )    ! barotropic i-current
@@ -1098,4 +1291,5 @@
       CALL wrk_dealloc( jpi,jpj,   zhf )
       IF( ln_wd ) CALL wrk_dealloc( jpi, jpj, zcpx, zcpy )
+      IF( ln_rwd ) CALL wrk_dealloc( jpi, jpj, ztwdmask, zuwdmask, zvwdmask, zuwdav2, zvwdav2 )
       !
       IF ( ln_diatmb ) THEN
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DYN/wet_dry.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DYN/wet_dry.F90	(revision 8864)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/OPA_SRC/DYN/wet_dry.F90	(revision 8865)
@@ -1,3 +1,6 @@
 MODULE wet_dry
+
+   !! includes updates to namelist namwad for diagnostic outputs of ROMS wetting and drying
+
    !!==============================================================================
    !!                       ***  MODULE  wet_dry  ***
@@ -32,13 +35,23 @@
 
    REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:) ::   wdmask         !: u- and v- limiter 
-   REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:) ::   ht_wd          !: wetting and drying t-pt depths
                                                                      !  (can include negative depths)
+   REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:) ::   wdramp, wdrampu, wdrampv ! for hpg limiting
 
    LOGICAL,  PUBLIC  ::   ln_wd       !: Wetting/drying activation switch (T:on,F:off)
+   REAL(wp), PUBLIC  ::   rn_wdmin0   !: depth at which wetting/drying starts
+   LOGICAL,  PUBLIC  ::   ln_rwd      !: ROMS Wetting/drying activation switch (T:on,F:off)
    REAL(wp), PUBLIC  ::   rn_wdmin1   !: minimum water depth on dried cells
-   REAL(wp), PUBLIC  ::   rn_wdmin2   !: tolerrance of minimum water depth on dried cells
+   REAL(wp), PUBLIC  ::   rn_wdmin2   !: tolerance of minimum water depth on dried cells
    REAL(wp), PUBLIC  ::   rn_wdld     !: land elevation below which wetting/drying 
                                            !: will be considered
    INTEGER , PUBLIC  ::   nn_wdit     !: maximum number of iteration for W/D limiter
+   LOGICAL,  PUBLIC  ::   ln_rwd_bc   !: ROMS scheme: True implies 3D velocities are set to the barotropic values at points 
+                                      !: where the flow is from wet points on less than half the barotropic sub-steps  
+   LOGICAL,  PUBLIC  ::   ln_rwd_rmp  !: use a ramp for the rwd flux limiter between 2 rn_wdmin1 and rn_wdmin1 (rather than a cut-off at rn_wdmin1)      
+   REAL(wp), PUBLIC  ::   rn_ssh_ref  !: height of z=0 with respect to the geoid; 
+   REAL(wp), PUBLIC  ::   rn_ht_0     !: the height at which ht_0 = 0   
+
+   LOGICAL,  PUBLIC  ::   ln_wd_diag  ! True implies wad diagnostic at chosen point are printed out
+   INTEGER , PUBLIC  ::   jn_wd_i, jn_wd_j, jn_wd_k   ! indices at which diagnostic outputs are generated 
 
    PUBLIC   wad_init                  ! initialisation routine called by step.F90
@@ -58,5 +71,7 @@
       !! ** input   : - namwad namelist
       !!----------------------------------------------------------------------
-      NAMELIST/namwad/ ln_wd, rn_wdmin1, rn_wdmin2, rn_wdld, nn_wdit
+      NAMELIST/namwad/ ln_wd, ln_rwd, rn_wdmin0, ln_rwd, rn_wdmin1, rn_wdmin2, rn_wdld, nn_wdit, ln_wd_diag, ln_rwd_bc, &
+                     &  rn_ht_0, jn_wd_i, jn_wd_j, jn_wd_k,ln_rwd_rmp
+
       INTEGER  ::   ios                 ! Local integer output status for namelist read
       INTEGER  ::   ierr                ! Local integer status array allocation 
@@ -78,13 +93,23 @@
          WRITE(numout,*) '~~~~~~~~'
          WRITE(numout,*) '   Namelist namwad'
-         WRITE(numout,*) '      Logical activation                 ln_wd      = ', ln_wd
+         WRITE(numout,*) '      Logical for NOC  wd scheme         ln_wd      = ', ln_wd
+         WRITE(numout,*) '      Logical for ROMS wd scheme         ln_rwd     = ', ln_rwd
+         WRITE(numout,*) '      Depth at which wet/drying starts rn_wdmin0    = ', rn_wdmin0
          WRITE(numout,*) '      Minimum wet depth on dried cells rn_wdmin1    = ', rn_wdmin1
          WRITE(numout,*) '      Tolerance of min wet depth     rn_wdmin2      = ', rn_wdmin2
          WRITE(numout,*) '      land elevation threshold         rn_wdld      = ', rn_wdld
          WRITE(numout,*) '      Max iteration for W/D limiter    nn_wdit      = ', nn_wdit
+         WRITE(numout,*) '      Logical for WAD diagnostics      ln_wd_diag   = ', ln_wd_diag
+         WRITE(numout,*) '      T => baroclinic u,v = 0 at dry pts: ln_rwd_bc = ', ln_rwd_bc     
+         WRITE(numout,*) '      use a ramp for rwd limiter:      ln_rwd_rmp   = ', ln_rwd_rmp
+         WRITE(numout,*) '      the height (z) at which ht_0 = 0:rn_ht_0      = ', rn_ht_0  
+         WRITE(numout,*) '      i-index for diagnostic point     jn_wd_i      = ', jn_wd_i
+         WRITE(numout,*) '      j-index for diagnostic point     jn_wd_j      = ', jn_wd_j
+         WRITE(numout,*) '      k-index for diagnostic point     jn_wd_k      = ', jn_wd_k
       ENDIF
       !
-      IF(ln_wd) THEN
-         ALLOCATE( wdmask(jpi,jpj), ht_wd(jpi,jpj),  STAT=ierr )
+      IF(ln_wd .OR. ln_rwd) THEN
+         ALLOCATE( wdmask(jpi,jpj),   STAT=ierr )
+         ALLOCATE( wdramp(jpi,jpj), wdrampu(jpi,jpj), wdrampv(jpi,jpj), STAT=ierr ) 
          IF( ierr /= 0 ) CALL ctl_stop('STOP', 'wad_init : Array allocation error')
       ENDIF
@@ -161,5 +186,5 @@
 
              IF( tmask(ji, jj, 1) < 0.5_wp ) CYCLE   ! we don't care about land cells
-             IF( ht_wd(ji,jj) > zdepwd )      CYCLE   ! and cells which are unlikely to dry
+             IF( ht_0(ji,jj)-rn_ssh_ref > zdepwd )      CYCLE   ! and cells which are unlikely to dry
 
               zflxp(ji,jj) = max(zflxu(ji,jj), 0._wp) - min(zflxu(ji-1,jj),   0._wp) + &
@@ -168,7 +193,7 @@
                            & min(zflxv(ji,jj), 0._wp) - max(zflxv(ji,  jj-1), 0._wp) 
 
-              zdep2 = ht_wd(ji,jj) + sshb1(ji,jj) - rn_wdmin1
+              zdep2 = ht_0(ji,jj) + sshb1(ji,jj) - rn_wdmin1
               IF(zdep2 .le. 0._wp) THEN  !add more safty, but not necessary
-                sshb1(ji,jj) = rn_wdmin1 - ht_wd(ji,jj)
+                sshb1(ji,jj) = rn_wdmin1 - ht_0(ji,jj)
                 IF(zflxu(ji,  jj) > 0._wp) zwdlmtu(ji  ,jj) = 0._wp
                 IF(zflxu(ji-1,jj) < 0._wp) zwdlmtu(ji-1,jj) = 0._wp
@@ -180,4 +205,21 @@
         END DO
 
+
+! slwa
+! HPG limiter from jholt
+      wdramp(:,:) = min((ht_0(:,:) + sshb1(:,:) - rn_wdmin1)/(rn_wdmin0 - rn_wdmin1),1.0_wp)
+!      write(6,*)'wdramp ',wdramp(10,10),wdramp(10,11)
+!jth assume don't need a lbc_lnk here
+       DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+           wdrampu(ji,jj) = min(wdramp(ji,jj),wdramp(ji+1,jj))
+           wdrampv(ji,jj) = min(wdramp(ji,jj),wdramp(ji,jj+1))
+         ENDDO
+       ENDDO
+        !wdrampu(:,:)=1.0_wp
+        !wdrampv(:,:)=1.0_wp
+! end HPG limiter
+
+
       
         !! start limiter iterations 
@@ -193,5 +235,5 @@
         
                  IF( tmask(ji, jj, 1) < 0.5_wp ) CYCLE 
-                 IF( ht_wd(ji,jj) > zdepwd )      CYCLE
+                 IF( ht_0(ji,jj) > zdepwd )      CYCLE
         
                  ztmp = e1e2t(ji,jj)
@@ -203,5 +245,5 @@
           
                  zdep1 = (zzflxp + zzflxn) * z2dt / ztmp
-                 zdep2 = ht_wd(ji,jj) + sshb1(ji,jj) - rn_wdmin1 - z2dt * sshemp(ji,jj)
+                 zdep2 = ht_0(ji,jj) + sshb1(ji,jj) - rn_wdmin1 - z2dt * sshemp(ji,jj)
           
                  IF( zdep1 > zdep2 ) THEN
@@ -317,5 +359,5 @@
 
              IF( tmask(ji, jj, 1 ) < 0.5_wp) CYCLE   ! we don't care about land cells
-             IF( ht_wd(ji,jj) > zdepwd )      CYCLE   ! and cells which are unlikely to dry
+             IF( ht_0(ji,jj) > zdepwd )      CYCLE   ! and cells which are unlikely to dry
 
               zflxp(ji,jj) = max(zflxu(ji,jj), 0._wp) - min(zflxu(ji-1,jj),   0._wp) + &
@@ -324,7 +366,7 @@
                            & min(zflxv(ji,jj), 0._wp) - max(zflxv(ji,  jj-1), 0._wp) 
 
-              zdep2 = ht_wd(ji,jj) + sshn_e(ji,jj) - rn_wdmin1
+              zdep2 = ht_0(ji,jj) + sshn_e(ji,jj) - rn_wdmin1
               IF(zdep2 .le. 0._wp) THEN  !add more safety, but not necessary
-                sshn_e(ji,jj) = rn_wdmin1 - ht_wd(ji,jj)
+                sshn_e(ji,jj) = rn_wdmin1 - ht_0(ji,jj)
                 IF(zflxu(ji,  jj) > 0._wp) zwdlmtu(ji  ,jj) = 0._wp
                 IF(zflxu(ji-1,jj) < 0._wp) zwdlmtu(ji-1,jj) = 0._wp
@@ -348,5 +390,5 @@
         
                  IF( tmask(ji, jj, 1 ) < 0.5_wp) CYCLE 
-                 IF( ht_wd(ji,jj) > zdepwd )      CYCLE
+                 IF( ht_0(ji,jj) > zdepwd )      CYCLE
         
                  ztmp = e1e2t(ji,jj)
@@ -358,5 +400,5 @@
           
                  zdep1 = (zzflxp + zzflxn) * z2dt / ztmp
-                 zdep2 = ht_wd(ji,jj) + sshn_e(ji,jj) - rn_wdmin1 - z2dt * zssh_frc(ji,jj)
+                 zdep2 = ht_0(ji,jj) + sshn_e(ji,jj) - rn_wdmin1 - z2dt * zssh_frc(ji,jj)
           
                  IF(zdep1 > zdep2) THEN
